

/*
 * This file: spec166.c
 *
 * 
 *
 *
 * Software from Tenison Technology
 * (C) 1990-1998 Tenison Technology 
 * Fax +44 1223 565917
 *
 * No responsibility can be accepted for loss or consequential loss.
 * Not for commercial use without license.  
 *
 * 
 * A C compiler and link editor is also available.  Contact info@tenisontech.com
 */

#include <stdio.h>
#include <stdlib.h>
#include "as166hdr.h"
#include <string.h>
#include <ctype.h>

#define TRC(X)

#define m_reg 1
#define m_dpp 2
#define m_reg_ind 3
#define m_immed 4
#define m_reg_bit 5
#define m_bsfr_bit 6
#define m_bsfr_whole 7
#define m_abs 8
#define m_reg_ind_inc 9
#define m_reg_ind_dec 10
#define m_bytereg 11
#define m_indexed 12


extern int vlookup(char *, int);
extern int readonlyopt;
extern int output;
extern char chcomma();
extern int eval();
extern char nextch(int skip);
void bulk();
extern void error();
extern int aschex();
extern void objword(unsigned short);
extern void objbyte(unsigned char);
extern int object[];
extern void symbnote();
extern int pass, xaddr, equate, baddr[], relorigin, error_type, tab, imed, running;
extern int equateval;
extern char *token, inst[], lable[];
extern char ech;
extern STNODE *stp;
extern STNODE *lhsnode, *wordnode;
extern FILE *objcis;
extern FILE *listcis;

int width, ovalue;
char tchar;

typedef struct ip_s
{
  char *name;
  int i, bversion;
  struct ip_s *next;
  void (*execute)();
} IP;

IP *iphashtab[255];

typedef struct parseitem 
{
  int dpp, mod, val, val1, index, bit;
  struct stnode *symb;
} PI;





IP *lookupip(char *name, int insertf)
{
  int h = (name[0] + (name[1]<<4)) & 255;
  IP *r = iphashtab[h];
  while(r)
    {
      if (!strcmp(r->name, name)) break;
      r = r-> next;
    }
  if (r && insertf) printf("opcode %s dmto\n", name); 
  if (r) return r;
  if (insertf)
    {
 
      r = NEW(IP);
      r->name = name;
      r->next = iphashtab[h];
      iphashtab[h] = r;
    }
  return r;
}


/* routine looks up nemonics  */
void lok()
{
  IP *ip;
  char nem [132];
  int i = 0;
  char xch = toupper(inst[tab++]);
  while (xch == ' ') xch = toupper(inst[tab++]);
  if (xch == (char) 0) return;       /* blank line */
  if (xch == ';')  return;           /* comment */
  while(isalpha(xch))
    {
      nem[i++] = xch;
      xch = toupper(inst[tab++]);
    }
  nem[i] = (char) 0;
  ip = lookupip(nem, 0);
  
  if (ip == NULL) 
    {
      error("bad instruction ", strdup(nem), "");
      
      printf(" bad bog `%s' %s\n", nem, inst);
    }
  else
    {
      nextch(1);
      (ip->execute)(inst+tab-1, ip);
    }
}


#if 0
int template(pat) char *pat;
{
  int i = tab-1;
  char tc = *pat;
  while(tc)
    {
      if (tc=='_') ps0.reg = inst[i] & 7;       /* address register chosen*/
      else if (toupper(inst[i]) != tc)  return 0;
      i = i + 1;
      tc = *(++pat);
    }
  tab = i;                         /* adopt template */
  nextch(1);
  return 1;
}
#endif



void advance(int i)
{
  tab = tab + i - 1;
  do {
    ech = inst[tab++];
  } while (ech == ' ' || ech == (char) 9);
}


void parse(PI *ps)
{
  /*  char *parsestart = inst+tab-1; */

  ps->mod = -1;  /* invalid value */

  /* find bit addressable things, including register names and register bits 
   */
  if (isalpha(ech))
    {
      int starttab = tab;
      char token[132];
      int i = 0;
      while (isalnum(ech) || (ech=='_') )       /* symbol look up */
      {
	token[i++] = toupper(ech);  /* ignore case in mnemnonics */
	nextch(0);
      }
      token[i++] = (char) 0;
      if (vlookup(token, 0))
	{
	  if (wordnode->type == GPREG)
	    {
      
	      if (ech == '.') /* actually a bit */
		{
		  nextch(1);
		  ps->bit = atoi(inst+tab-1);
		  while (isdigit(ech)) nextch(1);
		  ps->mod = m_bsfr_bit;
		  ps->val = 0xF0 + wordnode->value;
		}
	      else
		{
		  ps->mod = m_reg;
		  ps->val = wordnode->value;
		}
	      return;
	    }

	  if (wordnode->type == BYTEREG)
	    {
	      ps->val = wordnode->value;
	      ps->mod = m_bytereg;
	      return;
	    }

	  if (wordnode->type == BSFR)
	    {
	      ps->val = wordnode->bshort;
	      ps->val1 = wordnode->blong;
	      if (ech == '.') /* actually a bit */
		{
		  nextch(1);
		  ps->bit = atoi(inst+tab-1);
		  while (isdigit(ech)) nextch(1);
		  ps->mod = m_bsfr_bit;
		}
	      else  ps->mod = m_bsfr_whole;
	      return;
	    }

	  if (wordnode->type == SFR)
	    {
	      ps->val = wordnode->bshort;
	      ps->val1 = wordnode->blong;
	      ps->mod = m_bsfr_whole;
	      return;
	    }
	  
	  if (wordnode->type == SFBIT)
	    {
	      ps->mod = m_bsfr_bit;
	      ps->bit = wordnode->value;
	      ps->val = wordnode->bshort;
	      ps->val1 = wordnode->blong;
	      return;
	    }

	  
	}
      tab = starttab-1;
      nextch(1);
     
      /* otherwise, will lookup again in expression eval */
	
    }

  /* find register indirect [Rxx], [Rxx+] and [Rxx+nn] forms */
  if (ech == '[' && (inst[tab]=='R' || inst[tab]=='-'))
    {
      int decf = 0;
      int incf = 0;
      int indexf = 0;
      ps->val = atoi(inst+tab+1);
      nextch(1);
      if (ech == '-') { nextch(1); decf = 1; }
      nextch(1);
      while (isdigit(ech)) nextch(1);
      if (ech == '+') { nextch(1); incf = 1; }
      if (ech == ']') nextch(1);
      else 
	{
	  STNODE *poi;
	  int offset = eval(&poi);
	  ps->val1 = offset;
	  indexf = 1;
	  if (ech == ']') nextch(1);
	  else error("missing `]`");
	}
      ps->mod = 
	(indexf) ? m_indexed:
	(decf) ? m_reg_ind_dec: 
	(incf) ? m_reg_ind_inc: m_reg_ind;
      return;
    }

  if (ech == '#') /* find immediate addressing */
    {
      STNODE *poi;
      ps->mod = m_immed;
      ps->val = eval(&poi);
      return;
    }

  /* find dpp prefixed abs expressions */
  if (ech == 'd' && inst[tab] == 'p' && inst[tab+1] == 'p' && inst[tab+3] == ':')
    {
      STNODE *p0;
      ps->mod = m_dpp;
      ps->dpp = inst[tab+2] - '0';
      if (ps->dpp > 3) error("bad dpp number", "", "");
      advance(5);
      ps->val = eval(&p0);
      return;
    }

  {
    STNODE *poi;
    ps ->mod = m_abs;
    ps -> val = eval(&poi);
    return;
  }

  /*
  {

    printf("\n>%s<\n", parsestart);
    error("bad parse", "", "");

  }
  */
}



void install_i(char *name, void (*ex)())
{
  IP *r = lookupip(name, 1);
  r->name = name;
  r->execute = ex;
}

void install_ii(char *name, void (*ex)(), int i)
{
  IP *r = lookupip(name, 1);
  r->name = name;
  r->execute = ex;
  r->i = i;
}

void install_ib(char *name, void (*ex)(), int i)
{
  IP *r = lookupip(name, 1);
  r->name = name;
  r->execute = ex;
  r->i = i;
  r->bversion = 1;
}


void install_r(char *name, int val, int type)
{
  vlookup(name, 1);
  wordnode -> type = type;
  wordnode -> value = val;
}


/* treat any GP reg Rx present as a mapped SFR */
void augment_gpreg(PI * p)
{
  if (p->mod == m_reg) 
    {
      p->mod = m_bsfr_whole;
      p->val |= 0xF0;
    }
}



void get_dpp(int *pp)
{
  PI p;
  parse(&p);
  augment_gpreg(&p);
  if (p.mod != m_bsfr_whole) error("Bad sfr");
  *pp = p.val;
}

void get_im(int *pp)
{
  int r;
  STNODE *poi;
  if (ech != '#') error("immediate operand expected", "", "");
  r = eval(&poi);
  *pp = r;
  
}

struct conds
{
  int len;  char *name; int c; 
};

static struct conds ccs[] = 
{   
  { 6, "cc_net", 0x1 }, /* longest must be first */ 
  { 6, "cc_ult", 8 },
  { 6, "cc_ule", 15 },
  { 6, "cc_uge", 9 },
  { 6, "cc_ugt", 0xE },
  { 6, "cc_slt", 0xC },
  { 6, "cc_sle", 0xb },
  { 6, "cc_sge", 0xD },
  { 6, "cc_sgt", 0xA },
  { 5, "cc_uc", 0 },
  { 5, "cc_nz", 3 },
  { 5, "cc_nv", 5 },
  { 5, "cc_nc", 9 },
  { 5, "cc_eq", 2 },
  { 5, "cc_nn", 7 },
  { 5, "cc_ne", 3 }, 
  { 4, "cc_c", 8 },
  { 4, "cc_n", 6 }, 
  { 4, "cc_z", 2 },
  { 4, "cc_v", 4 },
  { 0, "", 0 }    
};




void get_cond(int *pp)
{
  int i=0;
  while(ccs[i].len)
    {
      if (!strncmp(inst+tab-1, ccs[i].name, ccs[i].len)) break;
      i ++;
    }
  if (ccs[i].len) 
    {
      *pp = ccs[i].c;
      advance(ccs[i].len);
      chcomma();
      return;
    }
  else
    {
      char *p = inst+tab;
      while (*p && *p != ',') p++; 
      if (*p == ',') error("bad condition", "", "");
    }
  *pp = 0; /* unconditional */
}


void objword_rev(unsigned int i)
{
  objword(((i>>8) & 255)+(i<<8));
}

void i_implied(char *v, IP *ip)
{
  objword(ip->i);
}

void i_scxt(char *v, IP *ip)
{
  PI ps0, ps1;
  parse(&ps0);
  chcomma();
  parse(&ps1);

  augment_gpreg(&ps0);

  if(ps0.mod == m_bsfr_whole && ps1.mod == m_immed)
    {
      objword(0xc600 + ps0.val);
      objword_rev(ps1.val);
    }
  else if (ps0.mod == m_bsfr_whole && ps1.mod == m_abs)
    {
      objword(0xD600 + ps0.val);
      objword_rev(ps1.val);
    }
  else error("Bad addressing modes");
}

void i_pushpop(char *v, IP *self)
{
  int dpp;
  get_dpp(&dpp);
  objword(self->i + dpp);
}



void i_nop(char *v, IP *self)
{
  /* */
}

static int isreg(int mod, int bytef)
{
  if (mod == m_reg)
    {
      if (bytef) error("bad size of register");
      return 1;
    }
  if (mod == m_bytereg)
    {
      if (bytef == 0) error("bad size of register");
      return 1;
    }
  return 0;
}


void i_cmpid(char *v, IP *self)
{
  PI ps0, ps1;
 
  parse(&ps0);
  chcomma();
  parse(&ps1);

  if (ps0.mod == m_reg && ps1.mod == m_immed)
    {
      if (ps1.val < 16)
	
	  objword(self->i + (ps1.val << 4) + ps0.val);
	
      else
	{
	  objword(self->i + 0x06F0 + ps0.val);
	  objword_rev(ps1.val);
	}
    }
  else if (ps0.mod == m_reg && ps1.mod == m_abs)
    {  
      objword(self->i + 0x02F0 + ps0.val);
      objword_rev(ps1.val);
    }
  else error("Bad addressing modes");
}

void genalu(char *v, IP *self, int bytef)
{
  PI ps0, ps1;
 
  parse(&ps0);
  chcomma();
  parse(&ps1);


  if (isreg(ps0.mod, bytef) && ps1.mod == m_reg)  /* r <= r op r */
    {
      objword(self->i - 0x0800 + (ps0.val << 4) + (ps1.val));
    }

  else if (isreg(ps0.mod, bytef) && ps1.mod == m_reg_ind)  /* r <= r op [Rn] */
    {
      if (ps1.val > 3) error("only R0 to R3 usable for index");
      objword(self->i - 0x800 + 0x0800 + (ps0.val << 4) + 0x08 + ps1.val);
    }

  else if (ps0.mod == m_bsfr_whole && ps1.mod == m_immed)  /* sfr <= sfr op imed */
    {
      objword(self->i - 0x800 + 0x0600 + (ps0.val));
      objword_rev(ps1.val);
    }

  else if (ps0.mod == m_bsfr_whole && ps1.mod == m_abs)  /* sfr <= sfr op abs */
    {
      objword(self->i - 0x800 + 0x0200 + (ps0.val));
      objword_rev(ps1.val);
    }

  else if (ps1.mod == m_bsfr_whole && ps0.mod == m_abs)  /* abs <= abs op sfr */
    {
      objword(self->i - 0x800 + 0x0400 + (ps1.val));
      objword_rev(ps0.val);
    }
  else if (isreg(ps0.mod, bytef) && ps1.mod == m_abs)  /* Rn <= Rn op abs */
    {
      objword(self->i - 0x800 + 0x0200 + 0xF0 + (ps0.val));
      objword_rev(ps1.val);
    }

  else if (ps1.mod == m_reg && ps0.mod == m_abs)  /* abs <= abs op Rn */
    {
      objword(self->i - 0x800 + 0x0400 + 0xF0 + (ps1.val));
      objword_rev(ps0.val);
    }


  else if (isreg(ps0.mod, bytef) && ps1.mod == m_reg_ind_inc)  /* r <= r op [Rn+] */
    {
      if (ps1.val > 3) error("only R0 to R3 usable for index");
      objword(self->i - 0x800 + 0x0800 + (ps0.val << 4) + 0x000C + ps1.val);
    }


 else if (isreg(ps0.mod, bytef) && ps1.mod == m_immed)  /* r <= r op #n */
    {
      if (bytef && ps1.val > 255) error("immediate val out of range");
      if (ps1.val >= 7) /* @@@ check sex */
	{
	  objword(self->i - 0x0200 + 0xf0 + ps0.val);
	  objword_rev(ps1.val);
	}
      else objword(self->i  + (ps0.val << 4) + ps1.val);  /* 4 bit form */
    }

  else error("bad alu addressing mode combination", "", "");

}

void i_bitop(char *v, IP *self)
{
  /* includes BAND etc:  op QQ ZZ qz */
  PI ps0, ps1;
 
  parse(&ps0);
  chcomma();
  parse(&ps1);

  augment_gpreg(&ps0);
  augment_gpreg(&ps1);

  if (ps0.mod == m_bsfr_bit && ps1.mod == m_bsfr_bit)
    {
      objword(self->i + ps1.val);
      objword((ps0.val << 8) | (ps1.bit << 4) | ps0.bit);
    }
  else error("Bad addressing modes");
}


void i_alub(char *v, IP *self)
{
  genalu(v, self, 1);
}


void i_trap(char *v, IP *self)
{
  int t;
  get_im(&t);
  objword(0x9B00 + (t << 1));
}

void i_aluw(char *v, IP *self)
{
  genalu(v, self, 0);
}

void i_jmps(char *v, IP *self)
{
  STNODE *p0, *ps1;
  int ss = eval(&p0);
  int mm;
  chcomma();
  mm = eval(&ps1);
  objword(0xfa00 + ss);
  objword_rev(mm);
}

void i_cjmpa(char *v, IP *self)
{
  int cond;
  int dest;
  STNODE *poi;
  get_cond(&cond);
  dest = eval(&poi);
  objword(self->i + (cond << 4));
  objword_rev(dest);
}

void i_calls(char *v, IP *self)
{
  int dest, seg;
  STNODE *poi, *segp;
  seg = eval(&segp);
  dest = eval(&poi);
  objword(self->i + seg);
  objword_rev(dest);
}



void i_bitjmp(char *v, IP *self)
{
  PI ps0;
  parse(&ps0);
  if (ps0.mod == m_bsfr_bit)
    {
      int dest, delta;
      STNODE *poi;
      chcomma();
      dest = eval(&poi);
      delta = (dest - (baddr[output] + 4)) >> 1;
      TRC(printf("Src %08X  Dest %08X, Delta %03X\n", baddr[output], dest, delta));
      if (delta > 127 || delta < -128) 
	{
	  error("out of range", "", "");
	}
      objword(self->i + ps0.val);
      objword((delta << 8) + (ps0.bit << 4));
	
      return;
    }

  
  else error("bit jump bad modes");
  printf("%i V", ps0.mod);
}

/* uncond relative jump and sub jump */
void i_reljmp(char *v, IP *self)
{
  STNODE *poi;
  int dest = eval(&poi);
  int delta = (dest - (baddr[output] + 2)) >> 1;
   
   if (delta > 127 || delta < -128) 
	{
	  error("out of range", "", "");
	}
  objword(self->i + ((delta & 255)));
  return;
}

  
void i_special(char *v, IP *self)
{
  objword(0xb748);
  objword(self->i);
}

void i_sys32(char *v, IP *self)
{
  objword((self->i >> 16) & 0xFFFF);
  objword(self->i & 0xFFFF);
}

void i_pwrdn(char *v, IP *self)
{
  objword(0x9768);
  objword(0x9797);
}

void i_shift(char *v, IP *self)
{
  PI dest, amount;
  parse(&dest);
  chcomma();
  parse(&amount);
  if (dest.mod == m_reg && amount.mod == m_reg)
    {
      objword(self->i + (dest.val << 4) + amount.val);
    }
  else if (dest.mod == m_reg && amount.mod == m_immed)
    {
      objword(0x1000 + self->i + (amount.val << 4) + dest.val);
    }
  else error("bad modes");
}

/* indirect jump */
void i_ijmp(char *v, IP *self)
{
  int cond;
  PI ps0;
  get_cond(&cond);
  parse(&ps0);

  if (ps0.mod == m_reg_ind)
    {
      objword(0x9C00 + (cond << 4) + ps0.val);
    }
  else error("badd mode", "", "");
}

/* conditional rel jump */
void i_jmpr(char *v, IP *self)
{
  int cond;
  int dest, delta;
  STNODE *poi;
  get_cond(&cond);

  dest = eval(&poi);
  delta = (dest - (baddr[output] + 2)) >> 1;
 
  if (delta > 127 || delta < -128) 
    {
      error("out of range", "", "");
    }
  objword((cond << 12)+ 0x0d00 + (delta & 0xFF));
}


void i_bsetclr(char *v, IP *self)
{
  PI ps0;
  parse(&ps0);
  if (ps0.mod == m_bsfr_bit)
    {
      objword((ps0.bit << 12) + self->i + ps0.val);
      return;
    }
  error("bad bit");
}

void i_atoexo(char *v, IP *self)
{
  int t;
  get_im(&t);
  /* The opcode may be wrong, so give error for now */
  error("atoexo instruction not supported");
  objword(self->i + (t << 4));
}
 

   
/* define a special function register - self indicates bit addressable */
void i_xsfrdef(char *v, IP *self)
{
  STNODE *ps0, *ps1;
  int blong = eval(&ps0);
  int bshort;
  chcomma();
  bshort = eval(&ps1);
 
  if (lhsnode)
    {
      lhsnode ->blong = blong;
      lhsnode ->bshort = bshort;
      lhsnode ->equatef = 1;
      lhsnode ->type = (self->i) ? BSFR: SFR;
    }
  else error("missing label");


}

/* equate directive 
 */
void i_equate(char *v, IP *self)
{
  STNODE *ps0;
  int vv = eval(&ps0);

   if (lhsnode)
    {
      if (pass == 1 && lhsnode ->equatef) lhsnode->type = DMTO;
      else
	{
	  lhsnode ->value = vv;
	  lhsnode ->equatef = 1;
	  lhsnode ->type = ABSOLUTE;
	}
    }
  else error("missing label");


}

/* Define a bit in a special function register */
void i_bitdef(char *v, IP *self)
{
  PI ps;
  STNODE *poi1;
  int bit;
  parse(&ps);
  chcomma();
  bit = eval(&poi1);
 
  if (ps.mod != m_bsfr_whole) error("not a bit addressable register"); 
  else if (lhsnode)
    {
      lhsnode ->value = bit;
      lhsnode ->bshort = ps.val;
      lhsnode ->blong = ps.val1;
      lhsnode ->equatef = 1;
      lhsnode ->type = SFBIT;
    }
  else error("missing label");

}


void i_movbx(char *v, IP *self)
{
  PI ps0, ps1;
  int bytef = 1;
 
  parse(&ps0);
  chcomma();
  parse(&ps1);


  if (isreg(ps0.mod, bytef) && isreg(ps1.mod, bytef))  /* Rxn <= Rbm */
    {
      objword(self->i + (ps1.val << 4) + (ps0.val)); /* backwards */
    }

  else if (ps0.mod == m_bsfr_whole && ps1.mod == m_abs)  /* sfr <= abs */
    {
      objword(self->i + 0x0200 + ps0.val);
      objword_rev(ps1.val);
    }
  else if (ps1.mod == m_bsfr_whole && ps0.mod == m_abs)  /* abs <= sfr */
    {
      objword(self->i + 0x0200 + ps1.val);
      objword_rev(ps0.val);
    }
  else error("Bad addressing modes");
}

void i_mulxprior(char *v, IP *self)
{
  PI ps0, ps1;
 
  parse(&ps0);
  chcomma();
  parse(&ps1);

  if (ps0.mod == m_reg && ps1.mod == m_reg)  /* Rwn, Rbm */
    {
      objword(self->i + (ps0.val << 4) + (ps1.val)); 
    }
  else error("Bad addressing modes");
}

void i_pcall(char *v, IP *self)
{
  PI ps0, ps1;
  parse(&ps0);
  chcomma();
  parse(&ps1);

  if (ps0.mod == m_reg && ps1.mod == m_abs)  /* PCALL reg,abs */
    {
      objword(0xE200 + ps0.val);
      objword_rev(ps1.val);
    }
  else error("Bad addressing modes");
}


void i_calli(char *v, IP *self)
{
  PI ps0;
  int cond;

  get_cond(&cond);
  chcomma();
  parse(&ps0);

  if (ps0.mod == m_reg_ind)
    {
      objword(0xAB00 + + (cond << 4) + ps0.val);
      
    }
  else error("Bad addressing modes");
}


void i_onereg(char *v, IP *self)
{
  PI ps0;
  parse(&ps0);
  if (isreg(ps0.mod, self->bversion))
    {
      objword(self->i + (ps0.val << 4) + 0); 
    }
  else error("Bad addressing modes");
}


void i_divx(char *v, IP *self)
{
  PI ps0;
 
  parse(&ps0);

  if (ps0.mod == m_reg)
    {
      objword(self->i + (ps0.val << 4) + ps0.val); 
    }
  else error("Bad addressing modes");
}

void i_onesfr(char *v, IP *self)
{
  PI ps0;
 
  parse(&ps0);

  if (ps0.mod == m_reg)
    {
      objword(self->i + 0xF0 + ps0.val); 
    }
  else if (ps0.mod == m_bsfr_whole)
    {
      objword(self->i + ps0.val); 
    }

  else error("Bad addressing modes");
}



void i_mov(char *v, IP *self)
{
  PI ps0, ps1;
  int bytef = self->i;
  parse(&ps0);
  chcomma();
  parse(&ps1);

  if (isreg(ps0.mod, bytef) && isreg(ps1.mod, bytef))  /* R <= R */
    {
      objword(0xF000 + (self->i << 8) + (ps0.val << 4) + (ps1.val));
    }

  else if (isreg(ps0.mod, bytef) && ps1.mod == m_reg_ind)  /* R <= [R] */
    {
      objword(0xA800 + (self->i << 8) + (ps0.val << 4) + (ps1.val));
    }

  else if (isreg(ps0.mod, bytef) && ps1.mod == m_indexed)  /* R <= [R+ind] */
    {
      objword(0xD400 + (self->i << 8) + (ps0.val << 4) + (ps1.val));
      objword_rev(ps1.val1);
    }

  else if (isreg(ps1.mod, bytef) && ps0.mod == m_indexed)  /*  [R+ind] <= R */
    {
      objword(0xC400 + (self->i << 8) + (ps1.val << 4) + (ps0.val));
      objword_rev(ps0.val1);
    }



  else if (ps0.mod == m_reg_ind && isreg(ps1.mod, bytef))  /* [R] <= R */
    {
      /* note nm in reverse order */
      objword(0xB800 + (self->i << 8) + (ps1.val << 4) + (ps0.val));
    }


  else if (ps0.mod == m_reg_ind_dec && isreg(ps1.mod, bytef))  /* [-R] <= R */
    {
      /* note nm in reverse order */
      objword(0x8800 + (self->i << 8) + (ps1.val << 4) + (ps0.val));
    }

  else if (ps1.mod == m_reg_ind_inc && isreg(ps0.mod, bytef))  /* R <= [R+] */
    {
      objword(0x9800 + (self->i << 8) + (ps0.val << 4) + (ps1.val));
    }

  else if (isreg(ps0.mod, bytef) && ps1.mod == m_immed)  /* R <= #n */
    {
      if (ps1.val >= 16 || ps1.val < 0) 
	{
	  objword(0xE6F0 + (self->i << 8) + ps0.val);
	  objword_rev(ps1.val);
	}
      else objword(0xE000 + (self->i << 8) + (ps1.val << 4) + ps0.val);  /* 4 bit form */
    }

  else if (ps0.mod == m_bsfr_whole && ps1.mod == m_immed)  /* SFR <= #n */
    {
	  objword(0xE600 + (self->i << 8) + ps0.val);
	  objword_rev(ps1.val);
    }


  else if (isreg(ps0.mod, bytef) && ps1.mod == m_dpp)  /* R <= DPP:ADDR */
    {
      objword(0xF2F0 + (self->i << 8) + ps0.val);
      objword_rev((ps1.dpp << 14) + (ps1.val & 0x3FFF));
    }
  
  else if (isreg(ps1.mod, bytef) && ps0.mod == m_dpp)  /* <= DPP:ADDR <= R */
    {
      objword(0xF6F0 + (self->i << 8) + ps1.val);
      objword_rev((ps0.dpp << 14) + (ps0.val & 0x3FFF));
    }


  else if (isreg(ps0.mod, bytef) && ps1.mod == m_abs)  /* R <= ADDR */
    {
      objword(0xF2F0 + (self->i << 8) + ps0.val);
      objword_rev(ps1.val);
    }
  
  else if (isreg(ps1.mod, bytef) && ps0.mod == m_abs)  /* ADDR <= R */
    {
      objword(0xF6F0 + (self->i << 8) + ps1.val);
      objword_rev(ps0.val);
    }

  else if (ps0.mod == m_bsfr_whole && ps1.mod == m_abs)  /* SFR <= ADDR */
    {
      objword(0xF200 + (self->i << 8) + ps0.val);
      objword_rev(ps1.val);
    }
  
  else if (ps1.mod == m_bsfr_whole && ps0.mod == m_abs)  /* ADDR <= SFR */
    {
      objword(0xF600 + (self->i << 8) + ps1.val);
      objword_rev(ps0.val);
    }
  else
    {
      /* printf("lhs=%i rhs=%i\n", ps0.mod, ps1.mod); 
       */
      error("bad mov addressing mode combination", "", "");
    }
}


void i_copy(char *v, IP *self)
{
  extern void gas_copy(int f);
  if (ech == '0') gas_copy(0);
  else if (ech == '1') gas_copy(1);
  else error("bad copy arg");
}

void i_data(char *v, IP *self)
{
  STNODE *p;
  while(2)
    {
      int o = eval (&p);
      objword_rev(o);
      if (ech == ',')
	{
	  nextch(1);
	}
      else if(ech == (char) 0) return;
      else error("comma expected");
    }
}

void i_bfdh(char *v, IP *self)
{
  int dpp;
  STNODE *sm, *sv;
  int m, val;

  get_dpp(&dpp);
  chcomma();
  m = eval(&sv) & 0xFF;  
  chcomma();
  val = eval(&sm) & 0xFF;
  objword(self->i + dpp);
  objword((val<<8) + m);
}


void i_get(char *v, IP *self)
{
  extern void gas_get();
  gas_get();
}


void i_origin(char *v, IP *self)
{
  STNODE *p;
  extern void org(int);
  int o = eval (&p);
  org(o);
}

void i_padorigin(char *v, IP *self)
{
  STNODE *p;
  extern void padorg(int);
  int o = eval (&p);
  padorg(o);
}


void initspecific()
{
  int i;
  for (i=0;i<256;i++) iphashtab[i] = NULL;
  install_r("R0", 0, GPREG);
  install_r("R1", 1, GPREG);
  install_r("R2", 2, GPREG);
  install_r("R3", 3, GPREG);
  install_r("R4", 4, GPREG);
  install_r("R5", 5, GPREG);
  install_r("R6", 6, GPREG);
  install_r("R7", 7, GPREG);

  install_r("RL0", 0, BYTEREG);
  install_r("RL1", 2, BYTEREG);
  install_r("RL2", 4, BYTEREG);
  install_r("RL3", 6, BYTEREG);
  install_r("RL4", 8, BYTEREG);
  install_r("RL5", 10, BYTEREG);
  install_r("RL6", 12, BYTEREG);
  install_r("RL7", 14, BYTEREG);

  install_r("RH0", 1, BYTEREG);
  install_r("RH1", 3, BYTEREG);
  install_r("RH2", 5, BYTEREG);
  install_r("RH3", 7, BYTEREG);
  install_r("RH4", 9, BYTEREG);
  install_r("RH5", 11, BYTEREG);
  install_r("RH6", 13, BYTEREG);
  install_r("RH7", 15, BYTEREG);

  install_r("R8", 8, GPREG);
  install_r("R9", 9, GPREG);
  install_r("R10", 10, GPREG);
  install_r("R11", 11, GPREG);
  install_r("R12", 12, GPREG);
  install_r("R13", 13, GPREG);
  install_r("R14", 14, GPREG);
  install_r("R15", 15, GPREG);

  install_i("TRAP", i_trap);

  install_ii("ATOMIC", i_atoexo, 0xD100);
  install_ii("EXTR", i_atoexo, 0xD180);
  install_ii("EXTP", i_atoexo, 0xDC40);
  install_ii("EXTPR", i_atoexo, 0xDCC0);
  install_ii("EXTS", i_atoexo, 0xDC00);
  install_ii("EXTSR", i_atoexo, 0xDC80);

  install_i("SCXT", i_scxt);
  install_ii("SRST", i_special, 0xB7B7);
  install_ii("IDLE", i_sys32, 0x87788787);
  install_ii("DISWDT", i_sys32, 0xA55AA5A5);
  install_ii("EINIT", i_sys32, 0xB54AB5B5);
  install_ii("SRVWDT", i_sys32, 0x97689797);

  install_i("PWRDN", i_pwrdn);
  install_ii("SHR", i_shift, 0x6C00);
  install_ii("SHL", i_shift, 0x4C00);
  install_ii("ASHR", i_shift, 0xAC00);
  install_ii("ROL", i_shift, 0x0C00);
  install_ii("ROR", i_shift, 0x2C00);

  install_ii("NOP", i_implied, 0xCC00);
  install_ii("RET", i_implied, 0xCB00);
  install_ii("RETI", i_implied, 0xFB88);
  install_ii("RETS", i_implied, 0xDB00);
  install_ii("RETP", i_onesfr, 0xEB00);
  install_i("SECTION", i_nop);
  install_i("END", i_nop);
  install_i("PRV", i_nop);
  install_ii("POP", i_pushpop, 0xFC00);
  install_ii("JBC", i_bitjmp, 0xAA00);
  install_ii("JB", i_bitjmp, 0x8A00);
  install_ii("JNB", i_bitjmp, 0x9A00);
  install_ii("JNBS", i_bitjmp, 0xBA00);
  install_ii("CALLR", i_reljmp, 0xBB00);
  install_ii("MOV", i_mov, 0);
  install_ii("MOVB", i_mov, 1);

  install_i("GLOBAL", i_nop);
  install_i("EXTERN", i_nop);
  install_i("REGBANK", i_nop);
  install_i("DAC", i_nop);
  install_i("ASM", i_nop);

  install_ii("BCMP", i_bitop, 0x2A00);
  install_ii("BMOVN", i_bitop, 0x3A00);
  install_ii("BMOVE", i_bitop, 0x4A00);
  install_ii("BOR", i_bitop, 0x5A00);
  install_ii("BAND", i_bitop, 0x6A00);
  install_ii("BXOR", i_bitop, 0x7A00);

  install_ii("ADD", i_aluw, 0x0800);
  install_ii("ADDC", i_aluw, 0x1800);
  install_ii("SUB", i_aluw, 0x2800);
  install_ii("SUBC", i_aluw, 0x3800);
  install_ii("CMP", i_aluw, 0x4800);
  install_ii("XOR", i_aluw, 0x5800);
  install_ii("AND", i_aluw, 0x6800);
  install_ii("OR", i_aluw, 0x7800);

  install_ii("ADDB", i_alub, 0x0900);
  install_ii("ADDBC", i_alub, 0x1900);
  install_ii("SUBB", i_alub, 0x2900);
  install_ii("SUBBC", i_alub, 0x3900);
  install_ii("CMPB", i_alub, 0x4900);
  install_ii("XORB", i_alub, 0x5900);
  install_ii("ANDB", i_alub, 0x6900);
  install_ii("ORB", i_alub, 0x7900);

  install_ii("MOVBS", i_movbx, 0xD000);
  install_ii("MOVBZ", i_movbx, 0xC000);

  install_ii("PUSH", i_onesfr, 0xEC00);
  install_ii("NEG", i_onereg, 0x8100);
  install_ib("NEGB", i_onereg, 0xA100);

  install_ii("CPL", i_onereg, 0x9100);
  install_ib("CPLB", i_onereg, 0xB100);


  install_ii("PRIOR", i_mulxprior, 0x2B00);
  install_ii("DIV", i_mulxprior, 0x4B00);
  install_ii("DIVL", i_mulxprior, 0x6B00);
  install_ii("DIVU", i_mulxprior, 0x5B00);
  install_ii("DIVLU", i_mulxprior, 0x7B00);
  install_ii("MUL", i_mulxprior, 0x0B00);
  install_ii("MULU", i_mulxprior, 0x1B00);

  install_i("CALLI", i_calli);
  install_i("PCALL", i_pcall);

  install_ii("CMPD1", i_cmpid, 0xA000);
  install_ii("CMPD2", i_cmpid, 0xB000);
  install_ii("CMPI1", i_cmpid, 0x8000);
  install_ii("CMPI2", i_cmpid, 0x9000);

  install_ii("BCLR", i_bsetclr, 0x0E00);
  install_ii("BSET", i_bsetclr, 0x0F00);
  install_i("JMPR", i_jmpr);
  install_i("JMPI", i_ijmp);
  install_ii("JMPA", i_cjmpa, 0xEA00);
  install_ii("CALLA", i_cjmpa, 0xCa00);
  install_ii("CALLS", i_calls, 0xDA00);
  install_i("JMPS", i_jmps);

  install_ii("BSFRDEF", i_xsfrdef, 1);
  install_ii("SFRDEF", i_xsfrdef, 0);
  install_ii("EQU", i_equate, 0);
  install_i("BITDEF", i_bitdef);
  install_i("SIMM", i_nop);
  install_i("COPY", i_copy);
  install_i("INCLUDE", i_get);
  install_i("GET", i_get);
  install_i("ORG", i_origin);
  install_i("PADORG", i_padorigin);
  install_i("DATA", i_data);
  install_ii("BFLDL", i_bfdh, 0x0a00);
  install_ii("BFLDH", i_bfdh, 0x1a00);



}


/* End of spec166.c */

